var user = {};
user.passwords = new Array();
user.getbacks = new Array();
user.securityEnabled = 0;
user.smbname='';
user.smbuser='admin';
user.smbpass='admin';

user.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8	
};

user.ResponseStrings = [ "Success", 
	    "Incorrect http method for this resource",
		"Unsupported return mime-type",
		"Unsupported attribute encountered for this resource",
		"Unknown attribute encountered for this resource",
		"Unknown property encountered for this resource",
		"Message parsing error",
		"Database IO error",
		"An unknown error was encountered"
		];

user.get = function(idx) {
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");			
		},
		url : "/cgi-bin/v1/users/user/" + idx + "?" + Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/users/user", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml) {
		
		var usersNode = $(xml).children("users");
		//alert(xml);
		var res = $(usersNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != user.ResponseCodes.SUCCESS) {
			//alert("Error: " + user.ResponseStrings[parseInt(res)]);
			return;
		}

		var userNode = $(usersNode).children("user");
        //user.cameras = userNode.length;
		
		for(i=0;i<userNode.length;i++)
	    {
	        var passwordNode = $(userNode[i]).children("password");
			if (passwordNode == undefined || passwordNode.attr("s") == undefined) 
			{
				user.passwords[i]="";
			} 
			else
			{
				user.passwords[i] = passwordNode.attr("s");				
			}
			
			passwordNode = $(userNode[i]).children("getback");
			if (passwordNode == undefined || passwordNode.attr("s") == undefined) 
			{
				user.getbacks[i] = "";
			} 
			else
			{
				user.getbacks[i] = passwordNode.attr("s");				
			}
			
	    }
		
	}
};


user.put = function(idx) 
{
	//var idx = $("#select_idx").val() + 1;
	//alert(idx);
	function serializeXML() {		

		var xml = '<?xml version="1.0"?>';
		xml += '<user>';		
		xml += '<user>';
		
		xml += '<password s="' +  $("#new_pass").val() + '" />';

		xml += '</user>';
		xml += '</user>';

		return xml;
	}

	var xml = serializeXML();

	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");			
			$("#L1406").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
			$("#reset").attr("disabled", true);
		},
		url : "/cgi-bin/v1/users/user/" + idx,
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#reset").attr("disabled", false);			
			handleError("/users/user/" + idx, "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#reset").attr("disabled", false);

		var userNode = $(result).children("users");
		var res = $(userNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != user.ResponseCodes.SUCCESS) {
				//alert("Error: " + user.ResponseStrings[parseInt(res)]);
				return;
			} else 
			{
				//alert(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
				$("#L1406").html(eval('tip_res.'+getCookieLanguage()+'["Password Changed Ok"]'));
			}
		}
	}
};

user.getsmb = function() {
	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");			
		},
		url : "/cgi-bin/v1/users/samba" + "?" + Math.random(),
		type : "GET",
		async : false,
		dataType : "xml",
		success : getSuccessHandler,
		error : function(err, textStatus) {
			handleError("/users/samba", "GET", err, textStatus);
		}
	});

	function getSuccessHandler(xml) {
		
		var smbNode = $(xml).children("smb");
		//alert(xml);
		var res = $(smbNode).children("res").attr("ul");
		if (res == undefined) {
			//alert("res not set");
			return;
		} else if (parseInt(res) != user.ResponseCodes.SUCCESS) {
			//alert("Error: " + user.ResponseStrings[parseInt(res)]);
			return;
		}
		
		var smb = $(smbNode).children("smbname");
		if (smb != undefined && smb.attr("s") != undefined) 		
		{
			user.smbname = html_entity_decode(smb.attr("s"));				
		}

		smb = $(smbNode).children("smbuser");
		if (smb != undefined && smb.attr("s") != undefined) 		
		{
			user.smbuser = html_entity_decode(smb.attr("s"));				
		}

		smb = $(smbNode).children("smbpass");
		if (smb != undefined && smb.attr("s") != undefined) 		
		{
			user.smbpass = html_entity_decode(smb.attr("s"));				
		}
	}
};

user.putsmb = function() 
{
	//alert(idx);
	function serializeXML() {		

		var xml = '<?xml version="1.0"?>';	
		xml += '<smb>';

		xml += '<smbname s="' +  $("#smb_name").val() + '" />';
        xml += '<smbuser s="' +  $("#smb_user").val() + '" />';
		xml += '<smbpass s="' +  $("#smb_pass").val() + '" />';

		xml += '</smb>';

		return xml;
	}

	var xml = serializeXML();

	$.ajax( {
		beforeSend : function(xhrObj) {
			xhrObj.setRequestHeader("Accept", "application/xml");
			xhrObj.setRequestHeader("Content-Type", "application/xml");			
			$("#L2901").html(eval('tip_res.'+getCookieLanguage()+'["Settings Updating"]'));
			$("#smb_btn").attr("disabled", true);
		},
		url : "/cgi-bin/v1/users/samba",
		type : "PUT",
		data : xml,
		dataType : "xml",
		success : putSuccessHandler,
		error : function(err, textStatus) {
			$("#smb_btn").attr("disabled", false);			
			handleError("/users/samba", "PUT", err, textStatus);
		}
	});

	function putSuccessHandler(result) {
		$("#smb_btn").attr("disabled", false);

		var userNode = $(result).children("smb");
		var res = $(userNode).children("res").attr("ul");

		if (res == undefined) {
			//alert("result not set");
			return;
		} 
		else 
		{
			if (parseInt(res) != user.ResponseCodes.SUCCESS) {
				$("#L2901").html('');
				return;
			} else 
			{
				//alert(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
				$("#L2901").html(eval('tip_res.'+getCookieLanguage()+'["Settings Update Ok"]'));
			}
		}
	}
};

user.setLoginValues = function() 
{ 
  $("#login").val(eval('button_res.'+getCookieLanguage()+'["Login"]'));
  $("#getback").val(eval('button_res.'+getCookieLanguage()+'["Get Back Password"]'));  
};

user.setLogoutValues = function() 
{ 
  $("#logout").val(eval('button_res.'+getCookieLanguage()+'["Logout"]'));
  $("#reset").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));  
  $("#smb_btn").val(eval('button_res.'+getCookieLanguage()+'["Apply"]'));
};

user.setSmbValues = function() 
{ 
  $("#smb_name").val(user.smbname);
  $("#smb_user").val(user.smbuser);
  $("#smb_pass").val(user.smbpass);
};
