#!/bin/sh

is_drv_loaded()
{	
	DRV_LOAD=1
	modules=`lsmod | cut -d " " -f 1` ;
	for i in $modules ;
	do
		echo $1 | grep -q $i  ;
		if [ $? == 0 ] ; then
			DRV_LOAD=0
			return 1;
		fi
	done
	return 0;
}

is_drv_loaded uvcvideo
if [ $DRV_LOAD -eq 1 ]
then
	mount -t jffs2 /dev/mtdblock7  /dvr

	#load the uvcvideo driver first
	#insmod /lib/modules/extra/uvcvideo.ko
	insmod /dvr/ko/uvcvideo.ko
       
	insmod /lib/modules/2.6.36/kernel/drivers/char/i2c_drv.ko
	
	insmod /lib/modules/2.6.36/kernel/sound/core/snd.ko
	insmod /lib/modules/2.6.36/kernel/sound/core/snd-timer.ko
	insmod /lib/modules/2.6.36/kernel/sound/core/snd-page-alloc.ko
	insmod /lib/modules/2.6.36/kernel/sound/core/snd-rawmidi.ko
	insmod /lib/modules/2.6.36/kernel/sound/core/snd-hwdep.ko
	insmod /lib/modules/2.6.36/kernel/sound/core/snd-pcm.ko
	
	insmod /lib/modules/2.6.36/kernel/sound/usb/snd-usbmidi-lib.ko
	#insmod /lib/modules/2.6.36/kernel/sound/usb/snd-usb-audio.ko
	insmod /dvr/ko/snd-usb-audio.ko	bInterval=0
	
	insmod  /lib/modules/2.6.36/kernel/drivers/usb/serial/usbserial.ko
	insmod  /dvr/ko/pl2303.ko

	/usr/sbin/inetd    
	
	rmmod    vfat
	rmmod    msdos
	rmmod    fat	
	insmod  /dvr/ko/fat.ko
	insmod  /dvr/ko/vfat.ko
	insmod  /dvr/ko/msdos.ko
	insmod  /dvr/ko/exfat.ko
	
	if [ -d "/dvr/testapp/updatepool" ]
        then
          cp -rf /dvr/testapp/updatepool/*  /dvr/testapp
          rm -rf /dvr/testapp/updatepool
        fi

	rm -rf /var/www/mobileye
	ln -s  /dvr/testapp   /var/www/mobileye	       
	
	mkdir -p  /tmp/ipc
	/data/app_start.sh
fi

