#!/bin/sh
#

dbg()
{
   	echo $1 > /dev/console
}

wrap_exit()
{
   	ret=$1;
   	#echo "1" > /tmp/mountDev
   	exit ${ret}  	
}

#fdisk_dev /dev/sda
fdisk_dev()
{
	if [ $# -lt 1 ]
	then
		dbg " pls input device"
		exit 2
	fi
    
	device=$1
	force=$2

	dbg "WARNING:fdisk... ${device} !!"  

	fdisk_app=/dvr/app/usrbin/fdisk

	 if [ "X${force}" == "X1" ]; then
	    $fdisk_app  -o 63   -f  ${device}
	 else
	    $fdisk_app  -o 63       ${device}
	 fi
	 
   RET=$?	
   if [ ${RET} -le 2 ]; then
   
   	  if [ ${RET} == 1 ]; then
   	      dbg  "error: failed to reread partition table "> /dev/console;
          wrap_exit 3
   	  fi   
   
      count=0
		  while [ $count -le 30 ]
		  do
			   if [ -e  "${device}1"  ]
			   then
				    break
			   else
				    sleep 1
			   fi
			   count=$((count+1))
		  done
		
		  if [ -e "${device}1" ]
		  then
			   dbg "fdisk ok"
			else
			   dbg "fdisk failed"
			   wrap_exit 4
		  fi
   fi     	
   
   dbg "fdisk ${device} OK "
} 


g_DEV=$1
 
dbg ""

# /dev/sda
len=${#g_DEV}
#dbg "len=${len}"
if [ "X${len}" != "X8" ] ; then
  dbg "can not fdisk ${g_DEV}, it's partition of device"
 	wrap_exit 0;	
fi

fdisk_dev   ${g_DEV}	1
  
wrap_exit 0;