#!/bin/sh
#

dbg()
{
   	echo $1 > /dev/console
}

wrap_exit()
{
   	ret=$1;
#   echo "1" > /tmp/mountDev
   	exit ${ret}  	
}


format_dev()
{
	if [ $# -lt 1 ]
	then
		dbg " pls input device"
		wrap_exit 2
	fi
  
	device=$1  

	dbg ""
	
	if [ "X$2" != "Xfat32" ]; then
		dbg "began to mkfs_exfat ${device} "  
		/dvr/app/usrbin/mkfs_exfat  ${device}
	else
		dbg "began to mkdosfs ${device} "  
		/dvr/app/usrbin/mkdosfs  -I  -v  ${device}
	fi
	if [ "X$?" != "X0" ]; then
		dbg  "error: failed to format ${device} "
		wrap_exit 5
	fi  
	
	dbg "format ${device} OK"
} 


g_DEV=$1
g_type=$2



dbg "DEV=${g_DEV}, type=${g_type}"

format_dev  ${g_DEV} ${g_type}

wrap_exit 0;
