var memcardlistdir = {};
memcardlistdir.listdir = new Array();

memcardlistdir.ResponseCodes = {
	"SUCCESS" : 0,
	"UNSUPPORTED_HTTP_METHOD" : 1,
	"UNSUPPORTED_RETURN_TYPE" : 2,
	"UNSUPPORTED_ATTRIBUTE" : 3,
	"UNKNOWN_ATTRIBUTE" : 4,
	"UNKNOWN_PROPERTY" : 5,
	"MESSAGE_PARSE_ERROR" : 6,
	"DATABASE_FAILURE" : 7,
	"UNKNOWN_ERROR" : 8,
	"MEMCARD_NOT_DETECTED" : 9
};

memcardlistdir.ResponseStrings = ["Success",
                                 "Incorrect http method for this resource",
                                 "Unsupported return mime-type",
                                 "Unsupported attribute encountered for this resource",
                                 "Unknown attribute encountered for this resource",
                                 "Unknown property encountered for this resource",
                                 "Message parsing error",
                                 "Database IO error",
                                 "An unknown error was encountered",
                                 "Memory card not detected"];

memcardlistdir.get = function() {
	$.ajax({
		beforeSend: function(xhrObj){
			xhrObj.setRequestHeader("Accept","application/xml");
		},
		url: "/cgi-bin/v1/storage/memcard/listdir?"+Math.random(),
		type: "GET",
		async: false,
		dataType: "xml",
		success: getSuccessHandler,
		error: function(err, textStatus) {
			handleError("/storage/memcard/listdir", "GET", err, textStatus);
		}
	});
	
	function getSuccessHandler( result ) {
		var storageNode = $(result).children("storage");
		
		var res = $(storageNode).children("res").attr("ul");
		if(res == undefined) {
			//alert("result not set");
			return;
		} else {
			if( parseInt(res) != memcardlistdir.ResponseCodes.SUCCESS ) {
				//alert("Error: "+memcardlistdir.ResponseStrings[parseInt( res )]);
				return;
			}
		}
		
		var memcardNode = $(storageNode).children("memcard");
		var listdirNode = $(memcardNode).children("listdir");
		
		var index = 0;
		memcardlistdir.listdir = new Array();
		$(listdirNode).find("dir").each(function() {
			var dirname = $(this).children("dirname").attr("s");
			dirname = unescape(dirname);
			memcardlistdir.listdir[index++] = dirname;
		});
	}
};

memcardlistdir.setValues = function () {
	var select2 = $("#selectList");
	$('option',select2).remove();
	select2.append($("<option></option>").
          	attr("value",rootFolder).
          	text("."+rootFolder));
	for (var index = 0; index < memcardlistdir.listdir.length; index++) {		
		select2.append($("<option></option>").
	          	attr("value",memcardlistdir.listdir[index]).
	          	text("."+rootFolder+memcardlistdir.listdir[index])); 
	}
	
	
};
